function chain = exampleChainVar(varargin)
%EXAMPLECHAINVAR  Example probabilistic computational chain definition
%
%   Example probabilistic computational chain definition
%
%   Syntax:
%   chain = exampleChainVar()
%
%   Input:
%   varargin  = none
%
%   Output:
%   varargout = Probabilistic computational chain structure
%
%   Example
%   chain = exampleChainVar
%
%   See also prob_chain, prob_chain_link, FORM, MC

%% Copyright notice
%   --------------------------------------------------------------------
%   Copyright (C) 2011 Deltares
%       Bas Hoonhout
%
%       bas.hoonhout@deltares.nl	
%
%       Rotterdamseweg 185
%       2629HD Delft
%
%   This library is free software: you can redistribute it and/or
%   modify it under the terms of the GNU Lesser General Public
%   License as published by the Free Software Foundation, either
%   version 2.1 of the License, or (at your option) any later version.
%
%   This library is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%   Lesser General Public License for more details.
%
%   You should have received a copy of the GNU Lesser General Public
%   License along with this library. If not, see <http://www.gnu.org/licenses/>.
%   --------------------------------------------------------------------

% This tool is part of <a href="http://OpenEarth.nl">OpenEarthTools</a>.
% OpenEarthTools is an online collaboration to share and manage data and 
% programming tools in an open source, version controlled environment.
% Sign up to recieve regular updates of this function, and to contribute 
% your own tools.

%% Version <http://svnbook.red-bean.com/en/1.5/svn.advanced.props.special.keywords.html>
% Created: 23 May 2011
% Created with Matlab version: 7.9.0.529 (R2009b)

% $Id: exampleChainVar.m 4595 2011-05-24 15:37:45Z hoonhout $
% $Date: 2011-05-24 17:37:45 +0200 (Tue, 24 May 2011) $
% $Author: hoonhout $
% $Revision: 4595 $
% $HeadURL: https://repos.deltares.nl/repos/OpenEarthTools/trunk/matlab/applications/probabilistic/examples/example/exampleChainVar.m $
% $Keywords: $

%% create struct

chain = struct(             ...
    'Method', {             ...
        @MC                 ...
        @MC                 ...
        @MC                 ...
        @FORM               ...
    },                      ...
    'Stochast', {           ...
        exampleStochastVar  ...
        exampleStochastVar  ...
        exampleStochastVar  ...
        exampleStochastVar  ...
    },                      ...
    'Params', {             ...
        {'IS',exampleISVar} ...
        {'IS',exampleISVar} ...
        {'IS',exampleISVar} ...
        {}                  ...
    },                      ...
    'Link', {               ...
        ''                  ...
        @prob_chain_link    ...
        @prob_chain_link    ...
        @prob_chain_link    ...
    },                      ...
    'LinkParams', {         ...
        {}                  ...
        {'sigma',.5}        ...
        {'sigma',.1}        ...
        {}                  ...
    }                       ...
);
